﻿]box on
)load isolate                                  

x←50 + ⌊ 0.5+ +\3 × ¯0.5+ ?8 12⍴0 ⍝ Stock prices (8 stocks, 1 year)
x[2;]←{⍵[1],¯1↓⍵} x[1;]           ⍝ x[2;] can be predicted by x[1;] 
⎕←x
2 ⎕FIX 'file://c:\docs\webinars\10\rsq.dyalog'
⎕CR 'rsq'
(¯1↓x[1;]) rsq 1↓x[3;]  ⍝ how well does x[1;] predict x[3;] ?
(¯1↓x[1;]) rsq 1↓x[2;]  ⍝ how well does x[1;] predict x[2;] ?       
¯1 1 (↓⍤0 1) 2↑x            
2 ⍕ r←(↓0 1↓x) ∘.rsq ↓0 ¯1↓x ⍝ How well does each series predict every other series?  
 
  r > 0.9                    ⍝ High r-squared statistic
⍸ r > 0.9                    ⍝ Indices where rsq is high        

⍝ Thanks to Roger Hui for the example!

x←50 + ⌊0.5 + +\3× ¯0.5 + ?1200 60⍴0  ⍝ 1,200 stocks, 5 years
x1←⌊(0.5+¯0.5+(¯1↑⍴x)⍴0)+¯5+1.2×x[1;] ⍝ add some noise and scale x[1;]
x[2;]←{⍵[1],¯1↓⍵} x1                  ⍝ shift right one period (as before)  
¯1 1 (↓⍤0 1) 2 12↑x
≢(⎕WA-100)⍴' '        ⍝ fully allocate workspace
t←⎕AI[3] ⋄ r←(↓0 1↓x) ∘.rsq ↓0 ¯1↓x ⋄ 'Elapsed ms: ',⎕AI[3]-t
⍴r
2⍕10 10↑r
+/,r > 0.96                        ⍝ count really high r-squared statistics
        +/, (r × ∘.≠⍨ ⍳≢r) > 0.96  ⍝ zero out the diagonal
{⍵,⍪r[⍵]} ⍸ (r × ∘.≠⍨ ⍳≢r) > 0.96  ⍝ {indices and statistics} where r > 0.96

⍝ Before I continue ... 
⊂↑⊃⎕NGET 'c:\docs\webinars\10\disclaimer.txt' 1

isolate.Config 'processors' 4  
isolate.Config 'maxws' '256M'
isolate.Config ''
is←ø '' ⍝ ø '' ←→ ¤ '' ←→ isolate.New '' ←→ create empty isolate  
]open taskmgr
is
is.wait←6
is.(wait×2)
waited←is.(⎕DL wait)
1 2 3 + 4 5 6
⎕←'We delayed for ',(1⍕waited),' seconds.'
)erase is

rsqpart←{(↓0 1↓x[⍵+⍳⍺;]) ∘.rsq ↓0 ¯1↓x} ⍝ ⍺=partition size, ⍺=offset  
⍴x                                    ⍝ 1200 stocks, 5 years
⍴2 rsqpart 0                          ⍝ compute rsq for x[1 2;] vs all 1200 rows
(8↑r) ≡ ⊃ ⍪/ 2 rsqpart¨ 0 2 4 6       ⍝ compute 4 2-row partitions and reassemble

iss←isolate.New¨ 4⍴⊂'rsq' 'rsqpart'   ⍝ 4 isolates containing rsq and rsqpart
iss.(≢(⎕WA-100)⍴' ')                  ⍝ Expand isolate workspaces
d←iss.⎕DL 3 6 9 12                    ⍝ (vector-of-spaces.⎕DL) is ⎕DL¨ (inside each space)
2↑d   ⍝ should wait until 6 seconds have passed
d     ⍝ must wait until 12 seconds have passed
iss.x←⊂x ⍝ transfer x to EACH of the 4 isolates
iss.(⍴x) ⍝ check that all x's arrived safely 

t←⎕AI[3] ⋄ z←⊃⍪/300 iss.rsqpart 0 300 600 900 ⋄ 'Elapsed ms: ',parallel←⎕AI[3]-t   
≢(⎕WA-100)⍴' '
t←⎕AI[3] ⋄ r←(↓0 1↓x) ∘.rsq ↓0 ¯1↓x           ⋄ 'Elapsed ms: ',serial←⎕AI[3]-t
z≡r                                              
serial÷parallel
⍝ End of Intro to Isolates
