﻿⍝ Remote Isolates
⍝ ]load c:\devt\aplssh\SSH        
]box off
]load c:\devt\isolate\source\root\AWS                             

iAWS←⎕NEW AWS

iAWS.user←'ubuntu'               ⍝ User name to log in to
iAWS.keyfolder←'C:\Users\mkrom\Documents\SSH\' ⍝ Where the key files are
iAWS.keypair←'AWS-JSONServer'    ⍝ Name of an AWS key pair
iAWS.region←'eu-west-1'          ⍝ Ireland
iAWS.image←'ami-ce366ab7'        ⍝ Ubuntu 16.04 with Dyalog APL 16.0 and updated isolate workspace
iAWS.type←'t1.micro'             ⍝ instance-type
iAWS.security←'Isolate ssh RIDE' ⍝ Ports to open
⎕←iAWS.SetMyIp                       

n←20

t←⎕AI[3] ⋄ instances←1 iAWS.RunInstances n ⋄ ⎕AI[3]-t
⎕←instances

⎕←cmd←'isolate=isolate Port=7052 AutoShut=1 AllowRemote="IP=',iAWS.myIP,'" dyalog /home/ubuntu/isolate'
t←⎕AI[3] ⋄ procs←iAWS.Launch n cmd ⋄ ⎕AI[3]-t

procs[1].Address  
procs[1].Command SH 'ps -ef|grep dyalog'      ⍝ Test Command channel (just for fun)
isolate.AddServer procs[1].Address 7052       ⍝ Add first VM as an Isolate Server
z←{isolate.AddServer ⍵.Address 7052}¨1↓procs  ⍝ Add all the rest

)erase iss           
n←n+4 ⍝ 20 remote, 4 local
iss←isolate.New¨n⍴⊂'rsq' 'rsqpart'
isolate.State ''
iss.(≢(⎕WA-100)⍴' ')                          ⍝ Expand isolate workspaces
⎕←platform←iss.(⊃'.' ⎕WG 'APLVersion')
⎕←lr←{⍺ ⍵}⌸platform
(local remote)←(⊂¨lr[;2])⌷¨⊂iss   
(local[1],remote[1]).('.' ⎕WG 'APLVersion')

x←50+⌊0.5++\3×¯0.5+?2400 60⍴0                 ⍝ 2,400 stocks this time
x[2;]←{⍵[1],¯1↓⍵}⌊(0.5+¯0.5+(¯1↑⍴x)⍴0)+¯5+1.2×x[1;] ⍝ x[2;] predictable from x[1;]

+/⎕←sizes←(≢¨local remote)/300 60 ⍝ local processors are more powerful
⎕←offsets←¯1↓+\0,sizes

⎕SIZE 'x'                              
t←⎕AI[3] ⋄ iss.x←⊂x ⋄ iss.(≢x) ⋄ 'Elapsed ms: ',⎕AI[3]-t   ⍝ transfer the data
⍝ Show the fish tank
t←⎕AI[3] ⋄ z←⊃⍪/sizes (local,remote).rsqpart offsets ⋄ 'Elapsed ms: ',⎕AI[3]-t  

+/sizes←(≢¨local remote)/250 70 ⍝ try a different balance between local/remote
offsets←¯1↓+\0,sizes
t←⎕AI[3] ⋄ z←⊃⍪/sizes (local,remote).rsqpart offsets ⋄ 'Elapsed ms: ',remote←⎕AI[3]-t 

t←⎕AI[3] ⋄ r←(↓0 1↓x) ∘.rsq ↓0 ¯1↓x ⋄ 'Elapsed ms: ',local←⎕AI[3]-t
r≡z
local÷remote     

⍝ Parallel Each on top of isolates
⎕←n←?100⍴4                                    ⍝ Times to delay
t←⎕AI[3] ⋄ +/(⎕DL ll.EachX iss) n ⋄ 'Elapsed ms: ',⎕AI[3]-t
 
z←#.isolate.RemoveServer¨ procs.Address ⋄ {}⎕TSYNC procs.TID

⎕←procs[1].Output ⍝ SSH session output from one of the processes
 
instances
1 iAWS.Terminate instances[;1]
